; Set up the scene quickly
Graphics3D 800,600
SetBuffer BackBuffer()
cube = CreateExampleCube()
cam = CreateCamera()
TranslateEntity cam, -5, -5, -5
PointEntity cam, cube
CameraViewport cam, 0, 0, GraphicsWidth (), GraphicsHeight ()

; the start rotation
Global pitch# = 0
Global yaw# = 0
Global roll# = 0

Repeat
	; update the rotation
	pitch = pitch + KeyHit(200) * 10 ; up
	pitch = pitch - KeyHit(208) * 10 ; down
	yaw   = yaw   + KeyHit(203) * 10 ; left
	yaw   = yaw   - KeyHit(205) * 10 ; right
	roll  = roll  + KeyHit(30)  * 10 ; a
	roll  = roll  - KeyHit(44)  * 10 ; z

	; rotate the cube
	RotateEntity cube, pitch, yaw, roll, 1

	; draw the scene
	UpdateWorld
	RenderWorld
	Text 10, 10, "Pitch:" + Int(EntityPitch (cube))
	Text 10, 20, "Yaw:  " + Int(EntityYaw (cube))
	Text 10, 30, "Roll: " + Int(EntityRoll (cube))
	Text 10, 50, "Use cursor keys, a, z, and escape to exit"
	Flip 1
Until KeyHit(1) ; escape

End

Function CreateExampleCube()
	; This will create & return a white cube with 3 coloured spikes going through it
	; to emphasise the rotations, and also a light
	Local cube = CreateCube()
	Local xspike = CreateCone(16, True, cube)
	Local yspike = CreateCone(16, True, cube)
	Local zspike = CreateCone(16, True, cube)

	Local tempBrush = CreateBrush(255, 255, 255)
	PaintEntity cube, tempBrush
	BrushColor tempbrush, 255, 0, 0
	PaintEntity xspike, tempBrush
	BrushColor tempbrush, 0, 255, 0
	PaintEntity yspike, tempBrush
	BrushColor tempbrush, 0, 0, 255
	PaintEntity zspike, tempBrush

	ScaleEntity xspike, 0.5, 4, 0.5
	ScaleEntity yspike, 0.5, 4, 0.5
	ScaleEntity zspike, 0.5, 4, 0.5

	RotateEntity xspike, 0, 0, 0, 1
	RotateEntity yspike, 90, 0, 0, 1
	RotateEntity zspike, 0, 0, 90, 1

	FreeBrush tempBrush

	Local light = CreateLight(1)
	PositionEntity light, -5, -5, -4

	Return cube
End Function
