; includes
Include "Quat.bb"

; Set up the scene quickly
Graphics3D 800,600
SetBuffer BackBuffer()
cube = CreateExampleCube()
cam = CreateCamera()
TranslateEntity cam, -5, -5, -5
PointEntity cam, cube
CameraViewport cam, 0, 0, GraphicsWidth (), GraphicsHeight ()

tempRot.Rotation = New Rotation
minusP.Quat = New Quat
plusP.Quat  = New Quat
minusY.Quat = New Quat
plusY.Quat  = New Quat
minusR.Quat = New Quat
plusR.Quat  = New Quat
cubeQuat.Quat = New Quat

; work out the quats for each key - minusP = rotate with negative pitch, plusY = rotate with positive yaw, etc
FillRotation(tempRot, -10, 0, 0) : EulerToQuat minusP, tempRot
FillRotation(tempRot, +10, 0, 0) : EulerToQuat plusP, tempRot
FillRotation(tempRot, 0, -10, 0) : EulerToQuat minusY, tempRot
FillRotation(tempRot, 0, +10, 0) : EulerToQuat plusY, tempRot
FillRotation(tempRot, 0, 0, -10) : EulerToQuat minusR, tempRot
FillRotation(tempRot, 0, 0, +10) : EulerToQuat plusR, tempRot
FillRotation(tempRot, 0, 0, 0)   : EulerToQuat cubeQuat, tempRot

Repeat
	; update the rotation
	; concatenated rotations are acheived by multiplying quats
	If KeyHit(200)      ; up
		MultiplyQuat(cubeQuat, cubeQuat, plusP)
	Else If KeyHit(208) ; down
		MultiplyQuat(cubeQuat, cubeQuat, minusP)
	Else If KeyHit(203) ; left
		MultiplyQuat(cubeQuat, cubeQuat, plusY)
	Else If KeyHit(205) ; right
		MultiplyQuat(cubeQuat, cubeQuat, minusY)
	Else If KeyHit(30)  ; a
		MultiplyQuat(cubeQuat, cubeQuat, plusR)
	Else If KeyHit(44)  ; z
		MultiplyQuat(cubeQuat, cubeQuat, minusR)
	EndIf

	; rotate the cube
	QuatToEuler tempRot, cubeQuat
	RotateEntity cube, tempRot\pitch, tempRot\yaw, tempRot\roll, 1

	; draw the scene
	UpdateWorld
	RenderWorld
	Text 10, 10, "Pitch:" + Int(EntityPitch (cube))
	Text 10, 20, "Yaw:  " + Int(EntityYaw (cube))
	Text 10, 30, "Roll: " + Int(EntityRoll (cube))
	Text 10, 50, "Use cursor keys, a, z, and escape to exit"
	Flip 1
Until KeyHit(1)

End

Function CreateExampleCube()
	; This will create & return a white cube with 3 coloured spikes going through it
	; to emphasise the rotations, and also a light
	Local cube = CreateCube()
	Local xspike = CreateCone(16, True, cube)
	Local yspike = CreateCone(16, True, cube)
	Local zspike = CreateCone(16, True, cube)

	Local tempBrush = CreateBrush(255, 255, 255)
	PaintEntity cube, tempBrush
	BrushColor tempbrush, 255, 0, 0
	PaintEntity xspike, tempBrush
	BrushColor tempbrush, 0, 255, 0
	PaintEntity yspike, tempBrush
	BrushColor tempbrush, 0, 0, 255
	PaintEntity zspike, tempBrush

	ScaleEntity xspike, 0.5, 4, 0.5
	ScaleEntity yspike, 0.5, 4, 0.5
	ScaleEntity zspike, 0.5, 4, 0.5

	RotateEntity xspike, 0, 0, 0, 1
	RotateEntity yspike, 90, 0, 0, 1
	RotateEntity zspike, 0, 0, 90, 1

	FreeBrush tempBrush

	Local light = CreateLight(1)
	PositionEntity light, -5, -5, -4

	Return cube
End Function
