Include "Quat.bb"

; Quickly set up a scene
Graphics3D 800,600
SetBuffer BackBuffer()
WireFrame True
Global cube = CreateCube()
Global cam = CreateCamera()
TranslateEntity cam, -5, -2, -5
PointEntity cam, cube
CameraViewport cam, 0, 0, GraphicsWidth (), GraphicsHeight ()

; We're going to rotate a cube between these two angles: (sp = start pitch, er = end roll, etc)
Global sp# = 90, sy# =  0, sr# =  0 ; The start rotation
Global ep# =  0, ey# =-90, er# = 90 ; The end rotation

; Start off by rotating the cube to it's initial rotation
RotateEntity cube, sp, sy, sr, 1
CaptureWorld : RenderWorld

Text 10, 10, "Press escape for ideal rotation" : Flip 1 : Repeat : Until KeyHit(1)

; Show the rotation we want to achieve, by using Blitz's tweening
RotateEntity cube, ep, ey, er, 1
For t = 0 To 200
	RenderWorld Float(t)/200
	Flip 1
Next
Text 10, 10, "Press escape for our own rotation" : Flip 1 : Repeat : Until KeyHit(1)

; Try to emulate the rotation
For t = 0 To 200
	RotateCube(Float(t)/200)
	CaptureWorld : RenderWorld
	Flip 1
Next

Text 10, 10, "Press escape to end" : Flip 1 : Repeat : Until KeyHit(1)
End

Function RotateCube(tween#)
	Local startQuat.Quat = New Quat
	Local midQuat.Quat = New Quat
	Local endQuat.Quat = New Quat
	Local startRot.Rotation = New Rotation
	Local midRot.Rotation = New Rotation
	Local endRot.Rotation = New Rotation

	; initialize the rotations
	FillRotation(startRot, sp, sy, sr)
	FillRotation(endRot,   ep, ey, er)

	; convert rotations to quats
	EulerToQuat startQuat, startRot
	EulerToQuat endQuat, endRot

	; do the interpolation
	QuatSlerp midQuat, startQuat, endQuat, tween

	; convert back to blitz-style eulers
	QuatToEuler midRot, midQuat

	RotateEntity cube, midRot\Pitch, midRot\Yaw, midRot\Roll, 1

	Delete startQuat
	Delete midQuat
	Delete endQuat
	Delete startRot
	Delete midRot
	Delete endRot
End Function
